// DateInterval.h  Datumsintervall-Berechner
//
// Berechnet aus einem vorgegebenen Datum das Datum fr ein bestimmtes 
// Intervall unter Beruecksichtigung der kalendarischen Daten. 
// Moegliche Intervalle sind:
//		nextDay, nextWeek, nextMonth, nextQuarter, nextYear, nextDecade
// ein gueltiges Eingabedatum liegt zwischen dem 1.1.1800 und dem 31.12.2100
//
// (c) 2003, oose.de GmbH
//////////////////////////////////////////////////////////////////////////

#ifndef DATE_INTERVAL_H
#define DATE_INTERVAL_H

const int MIN_YEAR = 1800;
const int MAX_YEAR = 2100;
const int MAX_MONTH = 12;
const int WEEK_LEN = 7;

const int LEAP_MONTH = 2;			// Der Februar
const int LEAP_MONTH_DAYS = 29;		// hat im Schaltjahr 29
const int REG_MONTH_DAYS = 28;		// sonst 28 Tage.

const int dayOfMonth[MAX_MONTH] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};


class DateInterval{
private:
	int day;
	int month;
	int year;

	int monthDays[MAX_MONTH];

	bool checkDate(int day, int month, int year);
	bool isLeapYear(int year);
	void updateDaysOfMonth();

public:
	DateInterval();
	~DateInterval();

	bool reset(int day, int month, int year);

	inline int getDay(){return day;};
	inline int getMonth(){return month;};
	inline int getYear(){return year;};

	void nextDay(int &day, int &month, int &year);
	void nextWeek(int &day, int &month, int &year);
	void nextMonth(int &day, int &month, int &year);
	void nextQuarter(int &day, int &month, int &year);
	void nextYear(int &day, int &month, int &year);
	void nextDecade(int &day, int &month, int &year);
};

#endif